//+------------------------------------------------------------------+
//|                                                 WININET_TEST.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//|        wininet.dll  |
//|   c http://codebase.mql4.com/ru/1064              |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|    wininet.dll                             |
//+------------------------------------------------------------------+
#import "wininet.dll"
int InternetAttemptConnect(int x);
int InternetOpenW(string sAgent,int lAccessType,
                  string sProxyName="",string sProxyBypass="",
                  int lFlags=0);
int InternetOpenUrlW(int hInternetSession,string sUrl,
                     string sHeaders="",int lHeadersLength=0,
                     int lFlags=0,int lContext=0);
int InternetReadFile(int hFile,uchar &sBuffer[],int lNumBytesToRead,
                     int &lNumberOfBytesRead[]);
int HttpQueryInfoW(int hRequest,int dwInfoLevel,
                   uchar &lpvBuffer[],int &lpdwBufferLength,int &lpdwIndex);
int InternetCloseHandle(int hInet);
#import
#define HTTP_QUERY_CONTENT_LENGTH 5
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
#property script_show_inputs
input string URL="http://yandex.ru"; // 
input string FileToSave="yandex.htm"; //  
//+------------------------------------------------------------------+
//|       addr                  |
//|       \MQL5\Files               |
//+------------------------------------------------------------------+
int FileLoadFromInternet(string addr,string filename)
  {
   int rv = InternetAttemptConnect(0);
   if(rv != 0)
     {
      Print("   InternetAttemptConnect()");
      return(-1);
     }

   int hInternetSession=InternetOpenW("Microsoft Internet Explorer",0,"","",0);
   if(hInternetSession<=0)
     {
      Print("   InternetOpenW()");
      return(-2);
     }

   int hURL=InternetOpenUrlW(hInternetSession,addr,"",0,0,0);
   if(hURL<=0)
     {
      Print("   InternetOpenUrlW()");
      InternetCloseHandle(hInternetSession);
      return(-3);
     }

//---          
//---  .     HttpQueryInfo 
//---      ContentSize_HttpQueryInfoW
//---    ,       
   int BufLen=2048;
   int ind=0;
   uchar buf0[2048];
   string s="";
   int ContentSize_HttpQueryInfoW=0;
   int iRes;

   iRes=HttpQueryInfoW(hURL,HTTP_QUERY_CONTENT_LENGTH,buf0,BufLen,ind);
   if(iRes<=0)
     {
      Print("   HttpQueryInfoW()");
     }
   else
     {
      s="";
      for(int k=0;k<BufLen;k++) { s=s+CharToString(buf0[k]);}
      if(StringLen(s)>0) ContentSize_HttpQueryInfoW=(int)StringToInteger(s);
     }

   if(ContentSize_HttpQueryInfoW>0)
     {
      Print(" =",ContentSize_HttpQueryInfoW);
     }
   else
     {
      Print("  ");
     }

   int dwBytesRead[1];
   bool flagret=true;
   uchar buffer[1024];
   int cnt=0;

   int h=FileOpen(filename,FILE_BIN|FILE_WRITE);
   if(h<=0)
     {
      Print("   FileOpen(),  ",filename,"",GetLastError());
      InternetCloseHandle(hInternetSession);
      return(-4);
     }

   while(!IsStopped())
     {
      bool bResult=InternetReadFile(hURL,buffer,1024,dwBytesRead);
      cnt+=dwBytesRead[0];
      if(dwBytesRead[0]==0) break;
      FileWriteArray(h,buffer,0,dwBytesRead[0]);
     }

   if(h>0) FileClose(h);

   if(cnt==0) FileDelete(filename);

   if(cnt==0)
     {
      Print("  ,   :",addr);
      InternetCloseHandle(hInternetSession);
      return(-5);
     }
   InternetCloseHandle(hInternetSession);

   return(0);
  }
//+------------------------------------------------------------------+
//|    OnStart                                  |
//+------------------------------------------------------------------+
int OnStart()
  {
//---
   if(TerminalInfoInteger(TERMINAL_DLLS_ALLOWED)==false)
     {
      Alert("     DLL");
      return(-1);
     }

   int iRes=FileLoadFromInternet(URL,FileToSave);
   if(iRes==0)
     {
      Alert("   ",URL,"  ",FileToSave);
     }
   else
     {
      Alert(" .    ");
     }

   return(0);
  }
//+------------------------------------------------------------------+
